#include "clipboard.h"

Clipboard::Block               Clipboard::block(0, 0);
SanetrackerDoc::Pattern        Clipboard::pattern;
SanetrackerDoc::Pattern::Track Clipboard::track;

Clipboard::Block::Block(uint width, uint height)
  : width(width),
    height(height)
{
  if(!(width * height))
    return;

  cells = new SanetrackerDoc::Pattern::Track::Cell[width * height];
}

Clipboard::Block::Block(const Block& block)
  : width(width),
    height(height)
{
  if(!(width * height))
    return;

  cells = new SanetrackerDoc::Pattern::Track::Cell[width * height];

  for(uint y = 0; y < height; ++y)
    for(uint x = 0; x < width; ++x)
      cells[y * width + x] = block.cells[y * width + x];
}

Clipboard::Block::~Block()
{
  if(!(width * height))
    return;

  delete [] cells;
}

SanetrackerDoc::Pattern::Track::Cell&
Clipboard::Block::operator()(uint x, uint y)
{
  return cells[y * width + x];
}

