/***************************************************************************
                          piano.h  -  description
                             -------------------
    begin                : Sat Jun 8 2002
    copyright            : (C) 2002 by Morten Hustveit
    email                : mortehu@ifi.uio.no
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef PIANO_H
#define PIANO_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

// include files for Qt
#include <qwidget.h>

/**
  *@author Morten Hustveit
  */

class Piano : public QWidget
{

Q_OBJECT

public: 
  
  Piano(QWidget* parent = 0, const char* name = 0);
  ~Piano();

  bool isSet(int note);

public slots:

  void keyPressed(uint note);
  void keyReleased(uint note);
  void allReleased();

protected:

  void resizeEvent(QResizeEvent* event);
  void updateKey(int note);
  void paintEvent(QPaintEvent* event);
  void mousePressEvent(QMouseEvent* event);
  void mouseReleaseEvent(QMouseEvent* event);
  void mouseMoveEvent(QMouseEvent* event);

private:
  
  QPoint lastPos;
  int    offset;
  bool   notes[128];

  int   f_width;  // Width of the white keys
  int   s_width;  // Width of the black keys
  int   s_height; // Height of the black keys
};

#endif
